
const int BUTTON_RELEASED       = 0000;
const int BUTTON_PRESSED        = 0001;
const int BUTTON_CLICKED        = 0002;
const int BUTTON_DOUBLE_CLICKED = 0003;
const int BUTTON_TRIPLE_CLICKED = 0004;
const int BUTTON_MOVED          = 0005; /* PDCurses enhancement */
const int BUTTON_ACTION_MASK    = 0007; /* PDCurses enhancement */
const int BUTTON_SHIFT          = 0010; /* PDCurses enhancement */
const int BUTTON_CONTROL        = 0020;  /* PDCurses enhancement */
const int BUTTON_ALT            = 0040;  /* PDCurses enhancement */
const int BUTTON_MODIFIER_MASK  = 0070;  /* PDCurses enhancement */

const int MOUSE_X_POS            =(Mouse_status.x);
const int MOUSE_Y_POS            =(Mouse_status.y);
const int A_BUTTON_CHANGED       =(Mouse_status.changes & 7);
const int MOUSE_MOVED            =(Mouse_status.changes & 8);
const int MOUSE_POS_REPORT       =(Mouse_status.changes & 16);

/* mouse bit-masks */
const int BUTTON1_RELEASED        =000000000001L;
const int BUTTON1_PRESSED         =000000000002L;
const int BUTTON1_CLICKED         =000000000004L;
const int BUTTON1_DOUBLE_CLICKED  =000000000010L;
const int BUTTON1_TRIPLE_CLICKED  =000000000020L;
const int BUTTON1_MOVED           =000000000020L ;/* PDCurses enhancement */
const int BUTTON2_RELEASED        =000000000040L;
const int BUTTON2_PRESSED         =000000000100L;
const int BUTTON2_CLICKED         =000000000200L;
const int BUTTON2_DOUBLE_CLICKED  =000000000400L;
const int BUTTON2_TRIPLE_CLICKED  =000000001000L;
const int BUTTON2_MOVED           =000000001000L ;/* PDCurses enhancement */
const int BUTTON3_RELEASED        =000000002000L;
const int BUTTON3_PRESSED         =000000004000L;
const int BUTTON3_CLICKED         =000000010000L;
const int BUTTON3_DOUBLE_CLICKED  =000000020000L;
const int BUTTON3_TRIPLE_CLICKED  =000000040000L;
const int BUTTON3_MOVED           =000000040000L ;/* PDCurses enhancement */
const int BUTTON_MODIFIER_SHIFT   =000000100000L; /* PDCurses enhancement */
const int BUTTON_MODIFIER_CONTROL =000000200000L; /* PDCurses enhancement */
const int BUTTON_MODIFIER_ALT     =000000400000L; /* PDCurses enhancement */
const int ALL_MOUSE_EVENTS        =000000777777L;
const int REPORT_MOUSE_POSITION   =000001000000L;

// the A_s heavily modified from original curses.d

const ulong A_NORMAL      =0x00000000L;                  /* System V */
const ulong A_ALTCHARSET  =0x00040000L;                  /* X/Open   */
const ulong A_BLINK       =0x00400000L;                  /* X/Open   */
// const ulong A_BLANK       =0x0000;                  /* X/Open   */
const ulong A_BOLD        =0x00800000L;                  /* X/Open   */
const ulong A_DIM         =0x00020000L;                  /* X/Open   */
const ulong A_RIGHTLINE   =0x00010000L;
const ulong A_LEFTLINE    = A_DIM;
const ulong A_INVIS       = 0x00080000L;
const ulong A_PROTECT     =( A_UNDERLINE | A_LEFTLINE | A_RIGHTLINE ); /* X/Open   */
const ulong A_REVERSE     =0x00200000L;                  /* X/Open   */
const ulong A_STANDOUT    =(A_REVERSE | A_BOLD);    /* X/Open   */
const ulong A_UNDERLINE   =0x00100000L;                  /* X/Open   */
const ulong A_COLOR       =0xFF000000L;                  /* System V  */
const ulong A_CHARTEXT    =0x0000FFFFL;                  /* X/Open   */
const ulong A_ATTRIBUTES  =0xFFFF0000L;           /* X/Open   */

const short COLOR_BLACK   = 0;
const short COLOR_BLUE    = 1;
const short COLOR_GREEN   = 2;
const short COLOR_CYAN    = 3;
const short COLOR_RED	  = 4;
const short COLOR_MAGENTA = 5;
const short COLOR_YELLOW  = 6;
const short COLOR_WHITE   = 7;

const int KEY_A1     =     0x1c1   /* upper left on Virtual keypad  */;
const int KEY_A2     =     0x1c2   /* upper middle on Virt. keypad  */;
const int KEY_A3     =     0x1c3   /* upper right on Vir. keypad    */;
const int KEY_B1     =     0x1c4   /* middle left on Virt. keypad   */;
const int KEY_B2     =     0x1c5   /* center on Virt. keypad        */;
const int KEY_B3     =     0x1c6   /* middle right on Vir. keypad   */;
const int KEY_C1     =     0x1c7   /* lower left on Virt. keypad    */;
const int KEY_C2     =     0x1c8   /* lower middle on Virt. keypad  */;
const int KEY_C3     =     0x1c9   /* lower right on Vir. keypad    */;
const int PADSLASH   =     0x1ca   /* slash on keypad               */;
const int PADENTER   =     0x1cb   /* enter on keypad               */;
const int CTL_PADENTER =   0x1cc   /* ctl-enter on keypad           */;
const int ALT_PADENTER =   0x1cd   /* alt-enter on keypad           */;
const int PADSTOP      =   0x1ce   /* stop on keypad                */;
const int PADSTAR      =   0x1cf   /* star on keypad                */;
const int PADMINUS     =   0x1d0   /* minus on keypad               */;
const int PADPLUS      =   0x1d1   /* plus on keypad                */;
const int CTL_PADSTOP  =   0x1d2   /* ctl-stop on keypad            */;
const int CTL_PADCENTER=   0x1d3   /* ctl-enter on keypad           */;
const int CTL_PADPLUS  =   0x1d4   /* ctl-plus on keypad            */;
const int CTL_PADMINUS =   0x1d5   /* ctl-minus on keypad           */;
const int CTL_PADSLASH =   0x1d6   /* ctl-slash on keypad           */;
const int CTL_PADSTAR  =   0x1d7   /* ctl-star on keypad            */;
const int ALT_PADPLUS   =  0x1d8   /* alt-plus on keypad            */;
const int ALT_PADMINUS  =  0x1d9   /* alt-minus on keypad           */;
const int ALT_PADSLASH  =  0x1da   /* alt-slash on keypad           */;
const int ALT_PADSTAR   =  0x1db   /* alt-star on keypad            */;
const int ALT_PADSTOP   =  0x1dc   /* alt-stop on keypad            */;
const int CTL_INS       =  0x1dd   /* ctl-insert                    */;
const int ALT_DEL       =  0x1de   /* alt-delete                    */;
const int ALT_INS       =  0x1df   /* alt-insert                    */;
const int CTL_UP        =  0x1e0   /* ctl-up arrow                  */;
const int CTL_DOWN      =  0x1e1   /* ctl-down arrow                */;
const int CTL_TAB       = 0x1e2   /* ctl-tab                       */;
const int ALT_TAB       =  0x1e3   /* alt-tab                       */;
const int ALT_MINUS     =  0x1e4   /* alt-minus                     */;
const int ALT_EQUAL     =  0x1e5   /* alt-equal                     */;
const int ALT_HOME      =  0x1e6   /* alt-home                      */;
const int ALT_PGUP      =  0x1e7   /* alt-pgup                      */;
const int ALT_PGDN      =  0x1e8   /* alt-pgdn                      */;
const int ALT_END       =  0x1e9   /* alt-end                       */;
const int ALT_UP        =  0x1ea   /* alt-up arrow                  */;
const int ALT_DOWN      =  0x1eb   /* alt-down arrow                */;
const int ALT_RIGHT     =  0x1ec   /* alt-right arrow               */;
const int ALT_LEFT      =  0x1ed   /* alt-left arrow                */;
const int ALT_ENTER     =  0x1ee   /* alt-enter                     */;
const int ALT_ESC       =  0x1ef   /* alt-escape                    */;
const int ALT_BQUOTE    =  0x1f0   /* alt-back quote                */;
const int ALT_LBRACKET  =  0x1f1   /* alt-left bracket              */;
const int ALT_RBRACKET   = 0x1f2   /* alt-right bracket             */;
const int ALT_SEMICOLON  = 0x1f3   /* alt-semi-colon                */;
const int ALT_FQUOTE     = 0x1f4   /* alt-forward quote             */;
const int ALT_COMMA      = 0x1f5   /* alt-comma                     */;
const int ALT_STOP       = 0x1f6   /* alt-stop                      */;
const int ALT_FSLASH     = 0x1f7   /* alt-forward slash             */;
const int ALT_BKSP       = 0x1f8   /* alt-backspace                 */;
const int CTL_BKSP       = 0x1f9   /* ctl-backspace                 */;
const int PAD0           = 0x1fa   /* ctl-keypad 0                  */;
const int CTL_PAD0       = 0x1fb   /* ctl-keypad 0                  */;
const int CTL_PAD1       = 0x1fc   /* ctl-keypad 1                  */;
const int CTL_PAD2       = 0x1fd   /* ctl-keypad 2                  */;
const int CTL_PAD3       = 0x1fe   /* ctl-keypad 3                  */;
const int CTL_PAD4       = 0x1ff   /* ctl-keypad 4                  */;
const int CTL_PAD5       = 0x200   /* ctl-keypad 5                  */;
const int CTL_PAD6       = 0x201   /* ctl-keypad 6                  */;
const int CTL_PAD7       = 0x202   /* ctl-keypad 7                  */;
const int CTL_PAD8       = 0x203   /* ctl-keypad 8                  */;
const int CTL_PAD9       = 0x204   /* ctl-keypad 9                  */;
const int ALT_PAD0       = 0x205   /* ctl-keypad 0                  */;
const int ALT_PAD1       = 0x206   /* ctl-keypad 1                  */;
const int ALT_PAD2       = 0x207   /* ctl-keypad 2                  */;
const int ALT_PAD3       = 0x208   /* ctl-keypad 3                  */;
const int ALT_PAD4       = 0x209   /* ctl-keypad 4                  */;
const int ALT_PAD5       = 0x20a   /* ctl-keypad 5                  */;
const int ALT_PAD6       = 0x20b   /* ctl-keypad 6                  */;
const int ALT_PAD7       = 0x20c   /* ctl-keypad 7                  */;
const int ALT_PAD8       = 0x20d   /* ctl-keypad 8                  */;
const int ALT_PAD9       = 0x20e   /* ctl-keypad 9                  */;
const int CTL_DEL        = 0x20f   /* clt-delete                    */;
const int ALT_BSLASH     = 0x210   /* alt-back slash                */;
const int CTL_ENTER      = 0x211   /* ctl-enter                     */;
const int SHF_PADENTER   = 0x212   /* shift-enter on keypad         */;
const int SHF_PADSLASH   = 0x213   /* shift-slash on keypad         */;
const int SHF_PADSTAR    = 0x214   /* shift-star  on keypad         */;
const int SHF_PADPLUS    = 0x215   /* shift-plus  on keypad         */;
const int SHF_PADMINUS   = 0x216   /* shift-minus on keypad         */;
const int SHF_UP         = 0x217   /* shift-up on keypad            */;
const int SHF_DOWN       = 0x218   /* shift-down on keypad          */;
const int SHF_IC         = 0x219   /* shift-insert on keypad        */;
const int SHF_DC         = 0x21a   /* shift-delete on keypad        */;
const int KEY_MOUSE      = 0x21b   /* "mouse" key                   */;
const int KEY_SHIFT_L    = 0x21c   /* Left-shift                    */;
const int KEY_SHIFT_R    = 0x21d   /* Right-shift                   */;
const int KEY_CONTROL_L  = 0x21e   /* Left-control                  */;
const int KEY_CONTROL_R  = 0x21f   /* Right-control                 */;
const int KEY_ALT_L      = 0x220   /* Left-alt                      */;
const int KEY_ALT_R      = 0x221   /* Right-alt                     */;
const int KEY_RESIZE     = 0x222   /* Window resize                 */;
const int KEY_SUP        = 0x223   /* Shifted up arrow              */;
const int KEY_SDOWN      = 0x224   /* Shifted down arrow            */;
const int KEY_MAX        = 0x224   /* Maximum curses key            */;


extern(C):

alias ushort chtype;
alias chtype attr_t;

struct MOUSE_STATUS
{
	int x;
	int y;
	short button[3];
	int changes;
}

struct WINDOW		/* definition of a window.	   */
{
	int	_cury;		/* current pseudo-cursor	   */
	int	_curx;
	int	_maxy;		/* max window coordinates	   */
	int	_maxx;
	int	_pmaxy;		/* max physical size		   */
	int	_pmaxx;
	int	_begy;		/* origin on screen		   */
	int	_begx;
	int	_lastpy;	/* last y coordinate of upper left pad display area */
	int	_lastpx;	/* last x coordinate of upper left pad display area */
	int	_lastsy1;	/* last upper y coordinate of screen window for pad */
	int	_lastsx1;	/* last upper x coordinate of screen window for pad */
	int	_lastsy2;	/* last lower y coordinate of screen window for pad */
	int	_lastsx2;	/* last lower x coordinate of screen window for pad */
	int	_flags;		/* window properties		   */
	attr_t	_attrs;		/* standard A_STANDOUT attributes and colors  */
	chtype	_bkgd;		/* wrs(4/6/93) background, normally blank */
	int	_tabsize;	/* tab character size		   */
	bit	_clear;		/* causes clear at next refresh	   */
	bit	_leaveit;	/* leaves cursor where it is	   */
	bit	_scroll;	/* allows window scrolling	   */
	bit	_nodelay;	/* input character wait flag	   */
	bit	_immed;		/* immediate update flag	   */
	bit	_sync;		/* synchronise window ancestors	   */
	bit	_use_keypad;	/* flags keypad key mode active	   */
	bit	_use_idl;	/* True if Ins/Del line can be used*/
	bit	_use_idc;	/* True if Ins/Del character can be used*/
	chtype**_y;		/* pointer to line pointer array   */
	int*	_firstch;	/* first changed character in line */
	int*	_lastch;	/* last changed character in line  */
	int	_tmarg;		/* top of scrolling region	   */
	int	_bmarg;		/* bottom of scrolling region	   */
	char*	_title;		/* window title			   */
	char		_title_ofs;	/* window title offset from left   */
	attr_t	_title_attr;	/* window title attributes	   */
	chtype	_blank;		/* window's blank character	   */
	int		_parx, _pary;	/* coords relative to parent (0,0) */
	WINDOW*	_parent;	/* subwin's pointer to parent win  */
}

struct ACTIVE			/* Refresh Window Structure	 */
{
	WINDOW*	win;
	ACTIVE*	next;
	ACTIVE*	tail;
}

struct WINDS
{
	WINDOW*		w;	/* pointer to a visible window	    */
	WINDS*	next;		/* Next visible window pointer	    */
	WINDS*	prev;		/* Next visible window pointer	    */
	WINDS*	tail;		/* Last visible window pointer	    */
				/* Only head window (stdscr) has    */
				/* a valid tail pointer.	    */
}

struct RIPPEDOFFLINE
{
	int line;
	int (*init)();
}

struct SCREEN
{
	bit	alive;		/* if initscr() called		    */
	bit	autocr;		/* if lf -> crlf		    */
	bit	cbreak;		/* if terminal unbuffered	    */
	bit	echo;		/* if terminal echo		    */
	bit	raw_inp;	/* raw input mode (v. cooked input) */
	bit	raw_out;	/* raw output mode (7 v. 8 bits)    */
	bit	refrbrk;	/* if premature refresh brk allowed */
	bit	orgcbr;		/* original MSDOS ^-BREAK setting   */
	bit	visible_cursor; /* TRUE if cursor is visible	    */
	bit	audible;	/* FALSE if the bell is visual	    */
	bit	full_redraw;	/* TRUE for bad performance	    */
	bit	direct_video;	/* Allow Direct Screen Memory writes*/
	bit	mono;		/* TRUE if current screen is mono.  */
	bit	sizeable;	/* TRUE if adapter is resizeable.   */
	bit	resized;	/* TRUE if TERM has been resized */
	bit	bogus_adapter;	/* TRUE if adapter has insane values*/
	bit	shell;		/* TRUE if reset_prog_mode() needs  */
				/*	to be called.		    */
	chtype	blank;		/* Background character		    */
	attr_t	orig_attr;	/* Original screen attributes	    */
	int	cursrow;	/* position of physical cursor	    */
	int	curscol;	/* position of physical cursor	    */
	int	cursor;		/* Current Cursor definition	    */
	int	visibility;		/* Visibility of cursor	*/
	int	video_page;	/* Current PC video page	    */
	int	orig_emulation; /* Original cursor emulation value  */
	int	orig_cursor;	/* Original cursor size		    */
	int	font;		/* default font size		    */
	int	orig_font;	/* Original font size		    */
	int	lines;		/* New value for LINES		    */
	int	cols;		/* New value for COLS		    */
	ulong _trap_mbe;		/* trap these mouse button events */
	ulong _map_mbe_to_key;	/* map mouse buttons to slk */
	int	slklines;		/* Lines in use by slk_init() */
	WINDOW *	slk_winptr;		/* window for slk */
	int	linesrippedoff;		/* Lines ripped off via ripoffline() */
	int	linesrippedoffontop;		/* Lines ripped off on top via ripoffline() */
	int	delaytenths;		/* 1/10ths second to wait block getch() for */
	bit	_preserve;		/* TRUE if screen background to be preserved */
	bit	_restore;		/* TRUE if screen background to be restored */
	bit	save_key_modifiers;		/* TRUE if each key modifiers saved with each key press */
	bit	return_key_modifiers;		/* TRUE if modifier keys are returned as "real" keys */

	int adapter;			/* Screen type	*/

	int	scrnmode;	/* default screen mode		    */
	uint video_seg;	/* video base segment		    */
	uint video_ofs;	/* video base offset		    */

	int	num_mouse_buttons;	/* number of mouse buttons */

	short	line_color;	/* Color of line attributes - default white */

}

/* Most Curses funtions */
int     	addchnstr( chtype *, int );
int     	baudrate( );
int     	beep(  );
int     	border( chtype, chtype, chtype, chtype, chtype, chtype, chtype, chtype );
int     	can_change_color (  );
int     	clearok( WINDOW*, bit );
int     	color_content( short, short*, short*, short* );
int     	copywin( WINDOW*, WINDOW*, int, int, int, int, int, int, int );
int     	curs_set( int );
int     	def_prog_mode( );
int     	def_shell_mode( );
int     	delay_output(  int  );
int     	delwin( WINDOW* );
WINDOW* 	derwin( WINDOW*, int, int, int, int );
int     	doupdate( );
WINDOW* 	dupwin( WINDOW* );
int     	endwin( );
int     	erase( );
char    	erasechar( );
int     	flash( );
int     	flushinp( );
int     	getsyx( int*, int* );
int     	halfdelay( int );
bit    	has_colors( );
int     	hline( chtype, int );
int     	immedok( WINDOW*, bit );
int     	inchnstr( chtype *, int );
int     	init_color( short, short, short, short );
int     	init_pair( short, short, short );
WINDOW* 	initscr( );
int     	intrflush(  WINDOW*, bit  );
int     	is_linetouched(WINDOW *,int);
int     	is_wintouched(WINDOW *);
char*   	keyname(  int  );
char    	killchar( );
char*   	longname( );
int     	meta( WINDOW*, bit );
int     	mvcur( int, int, int, int );
int     	mvderwin( WINDOW*, int, int );
int     	mvwaddnstr( WINDOW*,int,int,char*,int );
int     	mvwin( WINDOW*, int, int );
int     	mvwinsertln( WINDOW*, int, int );
WINDOW* 	newpad( int, int );
// SCREEN* 	newterm( char*, FILE*, FILE* );
WINDOW* 	newwin( int, int, int, int );
int     	noraw( );
int     	notimeout( WINDOW *, bit );
int     	overlay( WINDOW*, WINDOW* );
int     	overwrite( WINDOW*, WINDOW* );
int     	pair_content( int, short*, short* );
int     	pechochar( WINDOW *, chtype );
int     	pnoutrefresh( WINDOW*, int, int, int, int, int, int );
int     	prefresh( WINDOW*, int, int, int, int, int, int );
int     	raw( );
int     	refresh( );
int     	reset_prog_mode( );
int     	reset_shell_mode( );
int     	resetty( );
int     	ripoffline(int, int (*)(WINDOW *, int));
int     	savetty( );
int     	sb_init( );
int     	sb_set_horz(int, int, int);
int     	sb_set_vert(int, int, int);
int     	sb_get_horz(int *, int *, int *);
int     	sb_get_vert(int *, int *, int *);
int     	sb_refresh();
int     	scroll( WINDOW* );
SCREEN* 	set_term( SCREEN* );
int     	setsyx( int, int );
int     	start_color( );
int     	slk_init(int);
int     	slk_set(int, char *, int);
int     	slk_refresh();
int     	slk_noutrefresh();
char*   	slk_label(int);
int     	slk_clear();
int     	slk_restore();
int     	slk_touch();
int     	slk_attron(attr_t);
int     	slk_attrset(attr_t);
int     	slk_attroff(attr_t);
WINDOW* 	subpad( WINDOW*, int, int, int, int );
WINDOW* 	subwin( WINDOW*, int, int, int, int );
int     	syncok(WINDOW*, bit);
attr_t  	termattrs( );
char*   	termname( );
int     	touchline( WINDOW*, int ,int );
int     	touchwin( WINDOW* );
int     	typeahead( int );
char*   	unctrl( chtype );
int     	vline( chtype, int );
int     	waddchnstr( WINDOW*, chtype*, int );
int     	waddnstr( WINDOW*, char*, int );
int     	waddstr( WINDOW*, char* );
int     	wattroff( WINDOW*, ulong ); // CHANGED: attr_t -> ulong
int     	wattron( WINDOW*, ulong ); // CHANGED: attr_t -> ulong
int     	wattrset( WINDOW*, attr_t );
int     	wbkgd(WINDOW*, chtype);
void    	wbkgdset(WINDOW*, chtype);
int     	wborder( WINDOW*, chtype, chtype, chtype, chtype, chtype, chtype, chtype, chtype );
int     	wclear( WINDOW* );
int     	wclrtobot( WINDOW* );
int     	wclrtoeol( WINDOW* );
void    	wcursyncup(WINDOW*);
int     	wdelch( WINDOW* );
int     	wdeleteln( WINDOW* );
int     	werase( WINDOW* );
int     	wgetch( WINDOW* );
int     	wgetnstr( WINDOW*, char*, int );
int     	wgetstr( WINDOW*, char* );
int     	whline( WINDOW*, chtype, int );
int     	winchnstr( WINDOW*, chtype*, int );
int     	winnstr( WINDOW*, char*, int );
int     	winsch( WINDOW*, chtype );
int     	winsdelln( WINDOW*, int );
int     	winsertln( WINDOW* );
int     	winsnstr( WINDOW*, char*, int );
int     	wmove( WINDOW*, int, int );
int     	wnoutrefresh( WINDOW* );
char    	wordchar( );
int     	wredrawln( WINDOW*, int ,int );
int     	wrefresh( WINDOW* );
int     	wscrl( WINDOW*, int );
int     	wsetscrreg( WINDOW*, int, int );
int     	wtimeout( WINDOW *, int );
int     	wtouchln(WINDOW *, int, int, int);
void    	wsyncdown(WINDOW*);
void    	wsyncup(WINDOW*);
int     	wvline( WINDOW*, chtype, int );
int     	mouse_set( ulong );
int     	mouse_on( ulong );
int     	mouse_off( ulong );
int     	request_mouse_pos( );
int     	map_button( ulong );
void    	wmouse_position( WINDOW *, int *, int * );
ulong 	getmouse( );
ulong 	getbmap( );

int LINES;
int COLS;
WINDOW* stdscr;
WINDOW* curscr;
SCREEN* SP;
int use_emalloc;
MOUSE_STATUS Mouse_status;
int COLORS, COLOR_PAIRS;

// MISSING FROM ORIGINAL curses.d:

int waddch(WINDOW*, chtype);
int mvwaddch(WINDOW*, int, int, chtype);
int scrollok(WINDOW*, bool);
int wprintw(WINDOW *win, char *fmt, ...);
int mvwprintw(WINDOW *win, int y, int x, char *fmt,...);
int mvwaddstr(WINDOW *, int y, int x, char *str);
